﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.5
@EndOfDesignText@
'clsCSBuilderParser
'generate csBuilder from a list of spans, a json string or a json file


'CSBuilderParser v1.0
'dependencies :
' Core
' JSON
'parse a list of spans
'each span is a map with a span attribute, value (case unsentitive) can be :
' append
' icon
' bold
' underline
' strikethrough
' typeface
' alignment
' verticalAlign
' size
' relativesize
' scaleX
' image
' clickable
' color
' backgroundcolor

Sub Class_Globals
	Type TSpan(cs As CSBuilder,span As Map)
	Private fModule As Object
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(aModule As Object)
	fModule=aModule
End Sub

'return a CSBuilder from a JSON file
public Sub parseJsonFile(aDirName As String,aFileName As String,aEnableClick As Object) As CSBuilder
	Return parseJsonString(File.ReadString(aDirName,aFileName),aEnableClick)
End Sub

'return a CSBuilder from a JSON string which represents a list
public Sub parseJsonString(astring As String,aEnableClick As Object) As CSBuilder
	Log(astring)
	Dim JP As JSONParser
	JP.Initialize(astring)
	Return parseList(JP.NextArray,aEnableClick)
End Sub

'return a CSBuilder from a list
public Sub parseList(aSpans As List,aEnableClick As Object) As CSBuilder
	Dim cs As CSBuilder
	cs.Initialize
	parse(cs,aSpans)
	If aEnableClick<>Null Then
		cs.EnableClickEvents(aEnableClick)
	End If
	Return cs.PopAll
End Sub

private Sub setSpan(acs As CSBuilder,aspan As Map) As TSpan
	Dim s As TSpan
	s.Initialize
	s.cs=acs
	s.span=aspan
	Return s
End Sub

private Sub parse(acs As CSBuilder,aspans As List)
	For Each span As Map In aspans
		CallSub2(Me,"cs_" & span.Get("span"),setSpan(acs,span))
	Next
End Sub

private Sub cs_spans(acs As CSBuilder,aspans As List)
	If aspans.IsInitialized Then
		parse(acs,aspans)
	End If
End Sub

private Sub cs_icon(aspan As TSpan)
	Dim f As Map=CreateMap("FONTAWESOME":Typeface.FONTAWESOME _
		                  ,"MATERIALICONS":Typeface.MATERIALICONS)
	aspan.cs.Typeface(f.Get(aspan.span.GetDefault("typeface","FONTAWESOME")))
	aspan.cs.Append(Chr(Bit.ParseInt(aspan.span.Get("code"),16)))
	aspan.cs.pop
End Sub

private Sub cs_append(aspan As TSpan)
	Dim t As String=aspan.span.GetDefault("append","")
	If t<>"" Then
		aspan.cs.Append(t)
	End If
End Sub

private Sub cs_bold(aspan As TSpan)
	aspan.cs.Bold
	cs_spans(aspan.cs,aspan.span.GetDefault("spans",Null))
	aspan.cs.pop
End Sub

private Sub cs_underline(aspan As TSpan)
	aspan.cs.Underline
	cs_spans(aspan.cs,aspan.span.GetDefault("spans",Null))
	aspan.cs.pop
End Sub

private Sub cs_strikethrough(aspan As TSpan)
	aspan.cs.Strikethrough
	cs_spans(aspan.cs,aspan.span.GetDefault("spans",Null))
	aspan.cs.pop
End Sub

private Sub cs_typeface(aspan As TSpan)
	Dim f As Map=CreateMap("DEFAULT":Typeface.DEFAULT _
	                      ,"DEFAULT_BOLD":Typeface.DEFAULT_BOLD _
						  ,"MONOSPACE":Typeface.MONOSPACE _
						  ,"SANS_SERIF":Typeface.SANS_SERIF _
						  ,"SERIF":Typeface.SERIF)
	Dim s As Map=CreateMap("BOLD":Typeface.STYLE_BOLD _
	                      ,"ITALIC":Typeface.STYLE_ITALIC _
						  ,"BOLD_ITALIC":Typeface.STYLE_BOLD_ITALIC _
						  ,"NORMAL":Typeface.STYLE_NORMAL)
	aspan.cs.Typeface(Typeface.CreateNew(f.Get(aspan.span.GetDefault("typeface","SERIF")) _
	                                    ,s.Get(aspan.span.GetDefault("style","NORMAL"))))
	cs_spans(aspan.cs,aspan.span.GetDefault("spans",Null))
	aspan.cs.pop
End Sub

private Sub cs_size(aspan As TSpan)
	aspan.cs.Size(aspan.span.GetDefault("size",10))
	cs_spans(aspan.cs,aspan.span.GetDefault("spans",Null))
	aspan.cs.pop
End Sub

private Sub cs_relativeSize(aspan As TSpan)
	aspan.cs.RelativeSize(aspan.span.GetDefault("proportion",1))
	cs_spans(aspan.cs,aspan.span.GetDefault("spans",Null))
	aspan.cs.pop
End Sub

private Sub cs_scaleX(aspan As TSpan)
	aspan.cs.ScaleX(aspan.span.GetDefault("proportion",1))
	cs_spans(aspan.cs,aspan.span.GetDefault("spans",Null))
	aspan.cs.pop
End Sub

private Sub cs_color(aspan As TSpan)
	aspan.cs.color(HexToARGB(aspan.span.GetDefault("color","FFFFFFFF")))
	cs_spans(aspan.cs,aspan.span.GetDefault("spans",Null))
	aspan.cs.pop
End Sub

private Sub cs_backgroundColor(aspan As TSpan)
	aspan.cs.BackgroundColor(HexToARGB(aspan.span.GetDefault("backgroundColor","FF000000")))
	cs_spans(aspan.cs,aspan.span.GetDefault("spans",Null))
	aspan.cs.pop
End Sub

private Sub cs_alignment(aspan As TSpan)
	Dim s As String=aspan.span.GetDefault("alignment","ALIGN_NORMAL")
	aspan.cs.Alignment(s)
	cs_spans(aspan.cs,aspan.span.GetDefault("spans",Null))
	aspan.cs.pop
End Sub

private Sub cs_verticalAlign(aspan As TSpan)
	aspan.cs.VerticalAlign(aspan.span.GetDefault("shift",0)*1dip)
	cs_spans(aspan.cs,aspan.span.GetDefault("spans",Null))
	aspan.cs.pop
End Sub

private Sub cs_image(aspan As TSpan)
	Dim s As String=aspan.span.GetDefault("bmp","")
	If s<>"" Then
		If Starter.fBitmaps.ContainsKey(s) Then
			Dim bmp As Bitmap=Starter.fBitmaps.Get(s)
			aspan.cs.image(bmp _
			              ,aspan.span.GetDefault("width",bmp.Width) _
						  ,aspan.span.GetDefault("height",bmp.Height) _
						  ,aspan.span.GetDefault("baseline",False))
		Else
			CallSub2(Starter,"getBitmap",s)
		End If
	End If
End Sub

private Sub cs_clickable(aspan As TSpan)
	aspan.cs.Clickable("cs",CreateMap("eventName":aspan.span.GetDefault("eventName",""),"tag":aspan.span.GetDefault("tag","")))
	cs_spans(aspan.cs,aspan.span.GetDefault("spans",Null))
	aspan.cs.pop
End Sub

'convert hexadecimal string (AARRGGBB) to color
private Sub HexToARGB(ahex As String) As Long
	Dim a,r,g,b As Int
	a = Bit.ParseInt(ahex.SubString2(0,2), 16)
	r = Bit.ParseInt(ahex.SubString2(2,4), 16)
	g = Bit.ParseInt(ahex.SubString2(4,6), 16)
	b = Bit.ParseInt(ahex.SubString2(6,8), 16)
	Return Colors.ARGB(a,r,g,b)
End Sub

Sub cs_click(aevent As Object)
	Dim m As Map=aevent
	CallSub2(fModule,"cs_click",m)
End Sub